﻿[void][System.Reflection.Assembly]::LoadWithPartialName('presentationframework')
[xml]$XAML = @'
<Window
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        x:Name="Window"
            Title="AD User Expired" Height="529.885" Width="433.086">
    <Grid>
        <Image Name="image" HorizontalAlignment="Left" Height="77" Margin="10,0,0,0" VerticalAlignment="Top" Width="278"/>
        <Label Content="Password Expiration" HorizontalAlignment="Left" Margin="215,53,0,0" VerticalAlignment="Top" Foreground="#FF005176" FontWeight="Bold" FontSize="20" FontStyle="Italic"/>
        <Label Content="Search Base" HorizontalAlignment="Left" Margin="10,104,0,0" VerticalAlignment="Top" Foreground="#FF005176"/>
        <TextBox Name="SearchBase" HorizontalAlignment="Left" Height="23" Margin="10,126,0,0" TextWrapping="Wrap" Text="" VerticalAlignment="Top" Width="395" BorderBrush="#FF005176" Foreground="#FF005176"/>

        <TabControl HorizontalAlignment="Left" Height="321" Margin="10,150,0,0" VerticalAlignment="Top" Width="395" BorderBrush="#FF005176" Foreground="#FF005176">
            <TabItem Header="PWD will expired" Foreground="#FF005176" BorderBrush="#FF005176">
                <Grid>
                    <Label Content="PWD expire dans: " HorizontalAlignment="Left" Margin="10,8,0,0" VerticalAlignment="Top"/>
                    <TextBox Name="Tb_DayFutur" HorizontalAlignment="Left" Height="23" Margin="109,11,0,0" TextAlignment="Center" TextWrapping="Wrap" Text="10" VerticalAlignment="Top" Width="37" BorderBrush="#FF005176" Foreground="#FF005176"/>
                    <Label Content="jours" HorizontalAlignment="Left" Margin="147,8,0,0" VerticalAlignment="Top" RenderTransformOrigin="0.644,0.541"/>

                    <Button Name="Bt_Check" Content="Check" HorizontalAlignment="Left" Margin="198,10,-18,0" VerticalAlignment="Top" Width="75" Height="24" BorderBrush="#FF005176" Foreground="Black" Background="#FF00AAF6"/>
                    <ListView Name="ListView" Height="216" Margin="10,39,10,0" VerticalAlignment="Top" BorderBrush="#FF005176">
                        <ListView.View>
                            <GridView>
                                <GridViewColumn Header="Display Name" DisplayMemberBinding ="{Binding DisplayName}"/>
                                <GridViewColumn Header="Expired Date" DisplayMemberBinding ="{Binding ExpiryDate}"/>
                            </GridView>
                        </ListView.View>
                    </ListView>
                    <TextBox Name="Tb_OutputFile" HorizontalAlignment="Left" Height="23" Margin="10,260,0,0" TextWrapping="Wrap" Text="C:\Temp" VerticalAlignment="Top" Width="296" BorderBrush="#FF005176" Foreground="#FF005176"/>
                    <Button Name="Bt_Export" Content="Export" HorizontalAlignment="Left" Margin="311,260,0,0" VerticalAlignment="Top" Width="75" Height="23" BorderBrush="#FF005176" Foreground="Black" Background="#FF00AAF6"/>
                </Grid>
            </TabItem>
            <TabItem Header="PWD expired" Foreground="#FF005176">
                <Grid>
                    <Button Name="Bt_CheckExpired" Content="Check" HorizontalAlignment="Left" Margin="198,10,-18,0" VerticalAlignment="Top" Width="75" Height="24" BorderBrush="#FF005176" Foreground="Black" Background="#FF00AAF6"/>
                    <ListView Name="ListViewExpired" Height="216" Margin="10,39,10,0" VerticalAlignment="Top" BorderBrush="#FF005176">
                        <ListView.View>
                            <GridView>
                                <GridViewColumn Header="Display Name" DisplayMemberBinding ="{Binding DisplayName}"/>
                                <GridViewColumn Header="Expired Date" DisplayMemberBinding ="{Binding ExpiryDate}"/>
                            </GridView>
                        </ListView.View>
                    </ListView>
                    <TextBox Name="Tb_OutputFileExpired" HorizontalAlignment="Left" Height="23" Margin="10,260,0,0" TextWrapping="Wrap" Text="C:\Temp" VerticalAlignment="Top" Width="296" BorderBrush="#FF005176" Foreground="#FF005176"/>
                    <Button Name="Bt_ExportExpired" Content="Export" HorizontalAlignment="Left" Margin="311,260,0,0" VerticalAlignment="Top" Width="75" Height="23" BorderBrush="#FF005176" Foreground="Black" Background="#FF00AAF6"/>
                </Grid>
            </TabItem>
        </TabControl>

    </Grid>
</Window>

'@
#Read XAML
$reader=(New-Object System.Xml.XmlNodeReader $xaml) 
try{$Form=[Windows.Markup.XamlReader]::Load( $reader )}
catch{Write-Host "Unable to load Windows.Markup.XamlReader. Some possible causes for this problem include: .NET Framework is missing PowerShell must be launched with PowerShell -sta, invalid XAML code was encountered."; exit}

Import-Module ActiveDirectory

#===========================================================================
# Store Form Objects In PowerShell
#===========================================================================
$xaml.SelectNodes("//*[@Name]") | %{Set-Variable -Name ($_.Name) -Value $Form.FindName($_.Name)}

#*********************************************************
#Création de l'image en 64bits
#*********************************************************
# [convert]::ToBase64String((get-content 'D:\xxxx.png' -encoding byte))
$Logo = "iVBORw0KGgoAAAANSUhEUgAAAkwAAACRCAMAAAAGhRcpAAAC8VBMVEUAAAC+5PY4ruV9yu7w+f4Amt79/v5Pve709PSsvMGd1/LO6/ne8vsNoOFbu+klp+JTu+7m5uex4vaN0PBKtedswuyt3fT////+///2+vv+/v74+/z9/v77/v/9/f7+//7m5eX19fX
Gz9Hh4eL08/Pn9vz1+vz+//8DrOsxs+dbvuq6x8rQ1Nbc3t+v4Pbl5ufA5vXq6ert7evv7u7T7/rz9/kZreyvwMa5wsa8x81Ovu5jv+VXvenEz9J1yezL0dRux+7W19qL0e/Y2dvi4+Sz4va65PXr6+vN7v7b8Prw8PHm9/3y+Pr2+Pn3+vz4/P36/P0GqO
onr+mvv8M0sukkrug7t+y+xMlIu+xSvehMtOPO1Nh/zvLY3uTa3d2g2/PZ4OPd4eLl5+e95vjH6fjy8vPg8/sfqN+gv9E1qt+rvsGywsqlvMcMrOvBxslCseBSve47te+6zNVSvPJqxe1wwOR5yet1yeyX1fKQ0euQ1fOa1e2V1vSj3PKo2e6u4vbZ7PLp5
+jU7/vx8fHh8/uyv8OlvM2lxdQrtOnLzsrFychYv/FLvu2/0ddgxvCGxOyMx+O84O/H5POv4vXf5PLj4uPn8/bU7PYAqvYAk9wAqfUAqvUAqfYAqPQAqvcJo+cAqvMto9YAqPWWtsYAo+EApeyouLsAqfcAp/gAqvQAqfQAqPmouLoAqfMAqPYAp+4Ap/AA
qPMAqfIAqPAApeoqpNcAqvIAp/ICpegAqvgApvgAq/UAp+wAouAAp/oApvYApugApOVCp9KAssqpursAq/AiptuJtMcApe8RpuJprs9Wq89hrc6auclxr8mXuMcTqOkBp+Y0p9krptg9qNYzptVRqM+qwMqju8iTtsiduMMAqPIApO0FpeAXpNtGqthUq9V
tsc12s8pZqsm2wMOAssOrusKuvsAApuocqOYAoeYKpeMBo+Mrp94dpN5LqtForcZ1r8WQs8SVtcEJo+kipOMCot0totktotcsoNSLusva7FCPAAAAmHRSTlMAQL9+EO8M6zb7YDAg35/P236DcK+PUAIIJQYcChIOBIEzyo8+NCIE/vLf3rqafHdvZltVTy
/48+7n29jV1MPBwK+spoKAd2FdSkk4KyggGBX++/v49/Hu5+XjxKyglo6MhnxsZkI//v79/Pr59/Pp6OXd29HRvbamo6CemZKJhXNxVE5E+fft59vb2dHFw7u3r5OFfn5WVj+THa8AACN9SURBVHja7JrLy8xhFMetlB02xmWwed0WUi4LJCki92uILEgkS
e7XhSwUKSun7zkzjWH6Xaa5uL7kFXasKEvZ469wznlm8CK5bMzr+fT7nefcZvftec4zM8P+KYprh0Uif8fEsXvnzDx1dMu87WuGRSJ/xJjCur49M88u3j59/dt2f1Vo/85JwyKR32RC3/VlSxZf2bD+3ot2Xk7riSDPKm8ODB8WifwihSl9c2adWbR187Ra
q30bJEKsRliB3N8YxRT5hRNt4uoLM3ctWjh92rR2fylN00ZDBEL6kBgQSW6MiGKK/IwJU1bMOnli4fSXz1/cFmk+fZqUwRkzMRlQ2FymchRT5McUxq9auefc8W3TD76vtUuQALLKA6qXgTRlCjB1KN+PYooMZuqE8Stmzdyx8NC8gdadvMpZzlQu24jdaIA
oSVMgF7NMxA7cSaKYIp8pjN2759yOq5s+PL/Xn6bCJEkTSZqAM3YISoakTAKANMHgz8SZKaJ7UXFs34XzS2Zsmbe+1rqbA0LMrK+IaABTDExaGjpCBBCDRItivjAjzkz/O2OXz1xybPvmgdaLtgg1ACKYREBQI6BwU2MobFmGGmJhi7wbYqJCFNP/ytTimO
As+NhO66mfWHleEqGAgLpIsBwcJrImkLhjC4vn423uf2Nqcc3cOUtPHT186GJIzM8ePWZO0no9bVYRxGSGgwN4CDXirnRkpOZLURdEMf1PFFcu33168bYN02rt1kD73bVxnh15u5Qjr2SVO3ca2WNTkYDNUme6Jo2gLpkv9CUBUjwErFmimIY+hWLfnNGnF
2/d8Pxhix75CJRI5da+1V49UqloCOasXK8nAAhweZAaP8bAAoIw6wtGd+cCWaBpV59pLYpp6DKmsHbKimX6Q9qlg88GWrmIlHOGOHh869XssDNVuimYcYTQGbh9vkbYiMR1JnDtiD0ekAh5MQ7gQ5PheqLtOr5w07SBVn81aVbDVgIKujCfntyc/FlMIEt3
5usvsAVwVxjuhIR8V1QbZ6YhxtR1qy7OOrtjxqbXtf6nTwl5Ja+maVNACgbdzb4Wk9Y6LQwSAJ0+tkbxRR0KMElYwwLPSxTTkGFMoTi+b/f5RZcPzxt4VitVq8jzjEWvaCLNUuUBqIsIwhx06+aoL8ecpmDZ0Be0JO6KG9GQvY3c96JwyHsoHAfw3mfq+Dn
Ldy1ZsOV1q799p5RlWZJknAFVgeKzTpK6gBQmdK5m34rJO2CLd8KDUGCwS4dcTMz+eBuERR9oMX7P1PvsPTF988N2FY08a2TSBCVpwtWmj8QKSZIQ5yWgc5ABDGeQmBheRbdK5FYjIRH2MkxMcIV5ns1XawssiN+A9zrL7pEAkqhhzli1kwhL0ICDYIkQth
SPwIPF5LtPAPaQW99tzLCtzN0ugqW8DH/85Xib63WW1gAI+12Mu4Ow6Uhfy4HApDZIxMtWAH0jJoA6nSDXENwHsZdCFQIIM1gEVvy8mVmF4g+9vc7oGpgCQsxdn8PLnurkoVY8qcu3AzjDRyKADPZPuhc+AKtZwjrJHJgDr4uQgvhPy15HxQQBdWflrtFIF
HfthQUIaUCUQWIKTWLWAg6N6rtjIDSEJkc6sQvLrMTbXI/ziZ2r2XkbCIH+yyU/tdQmeXYHuPY9C8OsV06aSD0kUqod2SzL4vQyAoz5+vO3mhgQnR/N/k+FGW6B7ldmqkW3aQ4Hi3AwINOjhoYUChIyran7hUFcCd2wgIDSyPTlcDIhGaE8Zh3siyshw4LL
D40Vs8MeyGRIaJIdSXGBB1yoklWstNgZCIX/nmkeqrRvc1+OiEx8N8eKeshhoALjh8AihIbDlkyqfMFfcIoCXAyPPELh4ouV34K5Dcd9PYJMWWszkVVoXaXYrKhbMsVeWPwYHegtqajwQazGIg3giFObZ/p6RJojBMSBUnn0BPdpTvXuAX2+03pXtA+9/wG
cTAw2tc8EqZq6GFVGGmVz4K7PtAjNYlsOWQ1SfjF6KQ2KffFqBfiXw8kUbBJTycY1y+0ybeIHS5pNlVYs28jEWkqFPibsd5sGMg1qltouDAaD0XQBn9tw3NeDaY5InausGzFh55Kp0O7IlG0BWQgNF/i5RIebtRTdzGhQNN9LQ/NdZDqMv6au4e3g25wZrn
yZy3gRKLWUrD2m2Oac5DbN8VksBu90tXANq18u2HBKnaTKQ5MXaa4/VtVpMR26f0G/G38cuoZ3g5HJSolsDEWUvI0e6gKWxwKcB8hh9Qf4RIKKOmiwuApejKD0t1NRx9sYovsX/Ni7mBqd3guSSZSv7LaWwwgcwuklBi53M4Yc9Xub5hhnSB+GNzxtInEeI
q6A0hD6EmZfsH1GpuF0TW3a/Rj/mRhDj9/oGt4KpjlwBPcGxmW7Rz5y9fFtrjgYNEu1dJ8UZuMhhAgDVJAUeEqmkVT4dR7HWgr1U8mCkNxO/aGcHxuZPgaSKROY1D8XkDSoYMn5Ws3eYkD/muZgFcnxAg7pwlvyZsokKathPXU8JdPxlrw49eNIYhzmebhd
nCrXedh13XXny2UKZTjNOD8Np+HoOdIxDpBdwzvBAhxVcbaRDIknhyd9hwMkKkhsJNwfC/DwNVeggVEq2XQw1t94Hh4w4fehAfY8zXU/foSyH7qVTPPeg5Bbh90eRfbBt+eL882Vq+swj3OLTB8E+0x4fXelTEpi5dSRghgCg/jiO7+2ZArAL9b8RGe+KuD
7XHRRNqnCILjprWF8TqZ+N4FAK5kOMw+HS8jzPuTRK/PblAnxB0NZI9OHwDT3CGWR9ALbNAewACeoEbbRHzTk0xdk6k57X08dyZRrrYi6XVJo7rvLDMP5CsNlbGT6GCqZShkOXXFhF+aNh6R617Q0eiGN1QIcPckwxIL2Z2kXSOZTY5KFxwsy7Z1Iw/4pmW
5lE57zlWZ3a2T6GEgmQTpLLnCp0PXDmsZt4ah3Y7uYSzJDCYSK2jQnLvPGky5UqZUBpzUoKQwvyDTt+uNuek4mRqYD/Hd9NzAy/Wpk+hBYMykIAKmStAmp/H6mawZLD8XZY5pT9jVFIMOihad12sltuEkhvjWi+pcXZOouZ28xVTL184ZMQ9ZMu5BwGlkzH
RqZPoUamUziQjgJCcPiwMYyGC1rv+h+OK64ZaKEqm7kVxUassoncLLuOTT8ikzH222qZMoi6jgXMl1PR49e89gde1DLeRXKj6HQ7bBrn+feDfaZVoiyaHoyzWSgiCyPTcu8KjTuOt5iXFlWWdmBt6ThiwLcMSDW1D7TaUZXgMXRfjcM0Ug6nry9dCnn52mN
XefT3PpM70UtwEtpw62wtoGonUfRCF36MILiNn60zYCDxgCfzVAVa6D2KAVWHui/zzP1/d12qo3vjVK2XcMbwZqJoaJAUSohc6liZoT5yWBlJLsjU7oYCCSFmCsM1zbSqcBAmLU/wvx6BJkYiSAUZOFVk5flmm1IaBsyoSLi7IrLEK6pbacFSB6sNCjODUs
bjvt2cAQFn+/5tSSlaJhAojLsJCAIHO/GdrMnbvkQ/BGhQsKyKD/aIetxFNPtCmG+VbP2X+p8O4JMwRKVDEvQ3UQOqAmOwaBamMvjDHh4ctjbTEpvE8U1h4DB0thKOKtLvgRyWq79Re+34w97ZxJ7vxTFcZ0M7f+1oe0zhkisbLCQGGJJIhEbC7G1EVbCxo
7EwkoiIuJ/exFziCHEFIkFsRUSC5FYk4g9dt4Zrq/2VK9SwxPn//v3tbftfX3tp+ecnnvvKceZmCPWHDoP75kWWb0E5eIlVDSGiTZhanwYs0lTdItz2hzHFR5EF5x8hXz+b+aOXvRpzjEt4XpLHxM1TEEZyXMZXnYy0kzsf9NUKwmwaJiTapOqeJ3MqYflB
TH/T6VuPpH84495/4JD2A6m0HZGcyHJpC4TPwSRlnia538jmMQGeowUED54BkU8KzzpEvZaNdSpL06e7DY6AftDR6cGi5tK1aWQOiuTpUP4DwjBJN6yBJkEKIlnM0fynK+dJunC09IEJsHwl6wpGKUikInjPQg3MrgJY3k9rfRuzcsLT5wkKbc5AR3V9Rcp
ht3JqXTlbx3Cf0E3kc+kuQW9uDa0JG1yxJB2cCL3WWyRY001HerkuUjqYKI0hZeYS8cxTMErJLSgebV3DBWaU6KS0cnfSjWlf+GVBESQXWsP4T8Ek3Sd1GFMMuyfPWy+yEKatoPoMCWaH8EkhBBpUg9NaUcnGofYdIyoaiU/8DfA+z5MjWaK3vAn1pu0LKu
MWjBVbQtTGuQXnJoqdgjbS5Vl+5ni7WEKObiIAPp0wVC5cVcmiLdtc1jnab/x6AL5Av3kwjCVubDJ74KJe3UTT+0fubipOc2Hqnosbg4TlvKk19ugXHEI2+nfhdVbR8B1QiggTg2EMAaAZBoa0HTfsptUE3ZhA4mKpArU53QBAwqiUpNRgM+6FqaobA8TJG
mUpqgcKUycVJntm9ooWlaPXEPVVE4fGoV0FibeUa0X10cGTCvU16TocDqaCQlT2ZvXiObvHh5Oj3Js6qrjgyk4fHGajhYm5/WyD+r1hETetE4zUWjKCipg9qYOuCNKPOEi7AyCC7vv3snuTgya4xIuHELjzaHC32nmysN52fM16Y8RJj7+k0X0RjhSmAgd5
uOXlwkyLgMXa9uJOOehD5LVTOpfqXXzOhVnm4s9LCQ+ZBpLqWPd1ULCA8VRwsQ0xY/jWGEiA2UcI8+XH0kIVEIuVBNnEsiERby2aSK2RPxzxSkOk1BUHz4bUlBHCRNp1bihO0aYrn/7Zf+H5OUPn7tdYHrX+Y3kiR/PuDB2wK1CVBJUxwkTO3y7yL7HCNNZ
L7DHsl6e+u4rgeka94HbSJ764YybYgfcqHnL6Urlv6G92o6vV9ee+IXB7CBUlrEg7JJ3aVqF7sFpOqPssjStxzGbtKCaUtQeh8kaOvlSHALq1+/Ls4boz3L7y4q0n3e68rJueH1WIbh2ENopU2mne6QcTMUukD6VPs9JVxy2qPdyrNlMBC+ln3D/G68Pg9M
/I878Qb4P75t78mWsjtQR2eKpd+56MBZ9E8dbQ33lLEr1SUh9QncbCxyuBEkIyhmFYbyzpDG1x2CyspNfMT0EWEEeAhGaYHAo3UlImliUssKuD0WQyuyhspueTz2wGnvm8wHWHduLs95/0zn/rHt24Y/EFL31/KcC0zVvvuy8p9I1ddg/593rz9wSM3M9/a
TF5tFycvZauV5G7JXMZ5s1MoIGSmSCZLkSJvyK3TJMJajAirH0Nv46kjqfb9NJoFCmpKW5hSlvsKfcw0Y1VXLDXX7HC0//IXn7py8v4Yqu/fz995/eSD6+57x4kGmHWXuP6EWo2yRJsgY0cfs9GwCVbOZK1uAGssO9rOe1qEvUXq6HSdk+sQCTqNImy7pCY
Qr6oaNf1jLT42NVVZZmWN+JlT5IQWtUusm5arI9/ZxOFnIDU8c/Oesbhmk/p75rQfucx6/79pNPXhR5deYPMi795KozL5IT/NitqGBFHXb1J99cfUWsdY2PGr8gsxscpMthF3BnWwccVxI7F/amw8ljfrJfaufFah1MWLNfgOlEcTiSRA6qgjY72QUC81ru
Ewjtgna/nNXYsgNeqjXEyQJNgKlnHccblDQt7G9G2TlXnv5H5OJzzw6vZD334otP30Iuvvjms6NNKbijk5l7JC/0hoUiXwETn5S9tUhtmEe4EYezWwcTqMwWYEpNXHM/VYPlxHtJJyRUTQSmyii3EsYTJ2y6EcP1X+iQlY+OemddnN7wUjV9HKaFE7XDJTt
hfCo2e+UqmHBx+wWYbIx8h42mRhlalVmCf9cswtTYH9tOAKVFY02t+q75hjs2KXHUs5c+n/Wjfj9MlYk37MX1gF21ezfrYIL2WYRpb395arUwDjZdwtrCpM+u+cx29QSmZgZCHB2812OTZnTUJ8zNiEjmWphUjKapUYDIllFc28NUR64gjg3nYrcqaGnps1
6jqkirvjp7wx2bnMB9Mn/pO3PK18FkT1ShvIJUa1f3G8NkVIZhxT6NtDS/BqbcWivrOkyc/PmbChG/Gy+99LQ/JLdde6VUdd+ld5+2kdz9yKnR/rrl0j1idMdKmExMbh8AslFSEJZtD1NptYEF+QRXAlr2MZgiStya8hHCBh6D5Q1fv/nkk88+uV7e/OhRe
fS69z3/+pPbyOt3PhDtrwtW7KWvoLnWw4QT1Y4Xk3HAye7ebQwTvjPi4vJVhNuSr4Gpt8ha3wwLCw9vwPL6Fzg3hYpkxA3ZSVwYTudlJB267NLq5x86X5pTXgspnLy8ZR7pBJAQ/LAiFPAmv4wu0DEK8rqol754+KIFFnDhzKXHBumfg6nUEwVad0to4Cvj
MJnn6xUwpSgz9WN2DUyo0T5RLMMEhxsXodKG3ld0tKUjAAbtIBfSU/B1p6XwckJaL2Q9/9ll6IJCuGiOXtqf2aFZLtVVTAwyzIU0vESSbDG89M4tF0SCTKV9Ihkbg+xPwYQTBSMGtTcnfwymFBVHYMJRzQsOLl0FE7S8dYhiMPU4YNxwDJOTwZaam4IH/of
OkKHjv2bv9jTrwyCWDz8L/ZmepS1oFU1kp8FLlfxBc6M+5twvmAvCC309T15a6M9kVbkNx2YbwDRyGtJRjHRjmNoVMJ2MwJSsgGn52OIwoVUA4RoMKEA6JYd0b6RJgiAfF029IPEhOsfhFfQ80Z6XrMzwMh5UxytgDpEP46V3LEzGNttGoQ1hwomChxuFaf
/HmlOSLWDq/2aY8BhdmXANwyRDB8TohHzvmn+AC+lDGVHDd5ARTNKJm1cGbtzAQLrgJnlBdgh4cfWaAkUIde6pWZhgm+el2Agm62e3alcBUzIjJ9YFLREcXQlTm1ipTvn7YUIgAjccYGJq1K1W70izmIwTEzJn6uz4sWbSNCmDbnYgi4Sn4nIdttBpAG5wz
JQmNYwPDz8R0QwbwIQThY54uOQRH3cNTC27uWtgQpmRvx8m9PHCDYc+4BhwyfPeIZmpET/Mv6FAASFLF3TOeG/kjYP4UO6iMLW/CVNnojGrYbLxQZ2rxzDnW8CkTXNrYNpZa2q9mFUwFfgWQ2UUJkSHccNhdIoqIE1wEzLIq2Xidd6HDBdCgYGJSw06UoVX
LF3ID06uvGZX4WxPjm3hIkzNrKYvcYk3CA2M4389zje0wwYwCZfVGpjSiM79A6EB4GmaRiIwwX/FDQeY1GPS14SJE8PutOaA98QYTw4UyBi3CUzEhVOvW6NVvCFrIv7jStWaSkoLoVcf6ZDsK37vWcZ+7Yr8WZhwonb4RjTebAFTzQcSgynS7yOiaGIw4an
V9riJwoQn65a/FzAhrjSQ6IfkSlV/XImQYZmy5RgmL9RxRbwdLSJuFSpgS4gaZWvNtWKGOtlf2cfcD9zx62AyrfEFo2mDBvUWMFVw9KIw2YBaJNYQhclGZ83jRwQmxPxwwyE/kzNP7zBanPvGWjFnzRxkwKeYRVutCsJPkVwDiChZk4FYUAfi1sJkT1RPFU
9Of7EBTHmD44jDZA1j3KWPw4TzBkGHwxhMiJLqDQeYNAlq8Gu0aWQUYpL/PizaZF+QASnFsbEVrBn4IwLTbNdjC1CJTilzonVYmGxRx/impv9Q+edhqgFGHCbb0cgKOu4twnQi0jcOvlkMJvS96WlqclqGdzuHlg91u53kiZNNNN8ucTfJNcC+EkMprSOSa
06MmRImBlT9bi5jr14KxUguwVQDmQULkBdms7xOR+cvAhOaGvYGndr2DVkPU56i/+0KmMqYakqtampxX/W2znIGvxY3o4XJbtrSmUptGsJBgz8y5T8ii4AIMUZGQ7xyP/GZlBlyqXhHYdITlMIh/mvKXtWAJLwiEhqYH64FgPY4abhSsz2h98swoUW9NkqO
u+x3K2GyA7GgEeIwQZoIyftpvXmHambzfOzQ8w18ESExmBBBqXC2kVKHvWTxi71jbryEMpkuUTOaHYd0jElcocnCiTTal2vxjqmS2n9BxonmE/4YNh/esWpCA3F3EY4xyArnA2MMR3dTugwToroF12pDXc2I6aou9r8bpoqyfeH7YjBZr70YlZ/Idj2WUgy
VIylH3dyqGfufcI0t6MtMQyOWrXQ62gC1ImjpuEFXbBi36sLr5kVNVKJdVKY5LSUcwOaOt2KaSDRlJUNFLI4Sp4b61WXzBiYbAIDMd6VPNHFkRfM9o9WPIJHzfaKvF2CiryNJLLdcQyiXsXPZIkxZkC4kIgR9UZjsgMB0nysebYdLjfuo6BNeuZv03t6F2y
Bv0xw18rlKqFhPVpNHYcLeUIaAScRNnr8GnagwZmKinDcpdVh18d76ZCg55pkT1OSGULsa1gGeuvGZlh49rL4u8Rsh5tf2ckFS2mMJJj3Nc1pQpEmpEpF2CSYrPS7XGpjwy3aH7250vjODMCEjMPZ62A0qR40QAS0OE7rF7Mcwha5MHLRkmOSiS05wnvJK+
lDlNUw00yABSkd1ickLLxLXRj5xmAKv3oFW2kf8qoVsu9nEyi2Nb0p2o+S2e/NUPptrwLpo8w7/fmdgzRdO91Sa1mwdhQm0pObaV6NbbrS+sAOjkGsAHuXCLhGYatxwgImslLpILuTqZl3DSohEOxzp7MwLn6kA716lWkI7imQOV0smMYegyEh4R656IXNc
rIfziYlvUjZIu22wLCZJAirVLZbPYl4Vlt2vUK1LwBFJe5CmfWlqnDuEFtfbYFejxqJrbZioM9Ta26Af/5ol0BeT95+QR2dr5sIEocsBGUyjr6IXiuIyhIiVkUjQMkdHj9mfFVajgFLHJPnsBWlp1a+3reYucIK9bRVldpCStthAzCFUSz+24hQ57W9tktP
Py+bXViWtymd+DXYx5z028GwCU4gGACpt6gUDyMirRmmYOODYS4HRhN9CKKdfVREryJv7sCj7/f8inuMSM3yDzZw0yoorxI2+4X1zA5fzEs0xC2L8Jj4Tt8CRhL67VIW+24LRY5qc43VU7LxU6mUiBU/8D9MxCbrkAybtxSYU6bvjxd8WpaLLCpO8q8nEmQ
bVQ+ieRDuhTWbALF7Ggx1E/ofpmASj06cRcLyDGW1mxhPistBpe2rmGDDxrzHiSd7cwxNHS7yh/oWVfpAA1f+a6bjEdMlnmHTQSRiTwjFrLgtmzenbnXTcgJv1mWRy+Cfz4hKJhmPEHM1RWXhUHKhUIJJ59/+bMI9JTPYDdI5TAhzbNmFLggUHEXVDJo+Ik
bcQmqCljomTll4dXaljFNR0BgeKNRjDKfVzCw1N/tdMRyTaWdFqJkd/okAQng5J5JmlYN+0a4BxwAfZUb0ubfFVBeRCywrDqOFNPwR1NXiB1P3/jt6f2bt2HKmCGHgHuANX4BBcggOQchKSJ7uEEMkMIP4IIZAACUFEAjESKRFInICpV+W19r0Vea+6dujx
czezwZbaHtvtHgldxrH3maL+3jZu5IENEh+y77lcNOzMHKc1ubmqIBGlQtdK9Yh6mGQaB+qEtSdTH0shI/qAb5xEDlnbCOdMGeA8mTLNC/HK6yjLIbPMf308U2mVs9taps80ELZlHF2C4kYV+iG4fXA4qX1ns0MFwXlObovjqmDcRhK6QLwDnX2ZD1dIkYt
lKCk4yTQOdLpiRyYxR7HJJGX0ikxqkBkWM+qqb6rOkUkaMkqkSi7PhN61+YiRXKqvdZFFMIhjEZNMw+Dq7qKCPh6ubC8Jsz6Etgs4OwdwDOeBM/eXF9p0QXuTEyRcKim8EaHKUMpnX+WVnjOdMj5Ipk7Crc4y0leFKR7eXrKfRINt2a5NmqcdCS0AIhOh34
Fc3+w4BWYE/BLAJSg2T1HWztk6Su3ouOaJ485nChnIyvByECWpcXeelUTFs0DaVRd3p5kbHzoejrNuOgbl6O0qs1YoNLkPDRiiT7cQkGvOEYFIrYxVw7WqlHI6ZsaZRgfJBHS+FRpFHIcUSYWelID/HsLE9gHO7FIC8pxJlBo5zdzoYJxJ2Y860iaj020A+
IwqAndGFxcVxwFNuWYTkmzUDyrvkloiVS5BZc440+hYKy2zuJO9X9ioZTPDvQEs7iPghD6iPtLMVDeMDHdDSeWV/aXwBJd0ztzc6KADnpATbLL4FJu6lvbZN0Qgrc/c5eayOn1R9klN9+PJpeJPjjml3Hy+JZWOM83QwODgzkQC6GhSrKbODk7V1XYRW3AQ
KzZmrovIwTmYl5S6bzOfammE1NWtZ+5MlwAkk87UVvW3X+RXy56svAvlvZmLWtiWs+pZbDqp8XutyvK2pgM+POiAZ3pvql4T3qwgwxdnpydhBuz7M5GQgt/1mfUDycUuK7rENzjMnWl0XHm1PFnzJ/dxuHuAKy3tJy2Z6gxupU0ep3c7U1FHksNKmet/hjO
/EQDlPha+cNLRprkzjY47v17E4fjhfhzx8PFjmaDUN/nMdnYCSq8IF/UaMCGIqsMlibzlBboSPFWYIl26lwEVMwI+OE5X0T85HI/Hw/LgIR69hwxeR8AdDloaki/uttvGrOFSp+5EtwHI33k65TLgysdH7x98/hzHtydCHQ7VVQCyQK7V5nDuC9uWTBGRKG
6AUh8wIChS5lD8lCsG/Ubqcu5Mg+PG7Z9fvj199vLl53vvHrx+YdfIad906WUUGzJk8RCbSktEuFLJwalQBzkEJwp6oE2UgFg4uDXvTPQOj2s3r9/6++nrn++/3/x49uz5w4Sqv1fI3zkhE+DY79lkcgWdEP6+5hhlEp70rVDim17hXs6cnufm/rV3Lq9NB
GEA9yDif7C2ja2mwUsTSlPEB0gpLRSKr5sHUVQQRcWDf4EiCnrxJAwz47KulpnZZRM3idGkGmuqrY/6qm1tq1b7UBHfz4MnZ2fcbJWKr5Pt/JLsfvNtjh/7Pebbb/9/tHmL4y2bouGJp0NjPY96ux6ebUvfZ1gEUoghaELLHw+OGGOQHrMQF9qnGlwBpxqB
CrGUUXBdKrD4SCVWMdP0QZtXEd/SHDt0eOngl7FrA31dD++k0ynDFDkXIYkEJgAQ2yYsyw+YUPBj0RKVuuomtbRgucLQT9zkjAGO2F/2BLn0skHl5qYVWnl5WaQ13tS0YufghydvB3qfZ66cOpXKGq7B2hEmNJ/P0xwyUs4Pw74AKL13J0jn5L6bvwkDxVp
u1vmXhSC7eFUAPm2pCm1tqWtuCE9c4jb1prfrxcWzSTMHspezoGA6DiQ2vzMtmOzmMA6mqQbNB/4YVAjEpZ+XCJCqgE9ztPJFZa3Nmzc11Bwc6rw2UDx9NXP/zJljIJdj2fbzk41JPnGApY+TP+j7MCHIbND7Cacn4Cu/o5drVaflzEALLWytb2pcd2/wRO
e16/1dFzPJtPP5RkQaU1aWspHM74VZcMQaczGYQogmtwYjWa703+KLVdfAzKIqVLm/rnb9iomn3KYej+9ZI7TLzyXyhIgtF8QMB2IOj9cZsyBjgBCKAZKjm0ttJ/w/JQeIgNQpNzcT0SrLVrZUV2/c2KqJ9ZFtXtHTPWZCiBAhlHr+y2FcADq2LFmS9L7yB
KCQBMgfNudpsSpazlg0X5i9d/uTm9f7Pn1sa0u6mELHYQjptp2/YNk2YCyIuQMJCSFQQKFQdyaFtmpf7fpwzbPhbm5TIu9zCUWXLxs6cpiFKfF7CVBgPiLqFkoJAsrNKUp539rFc7nvCy/dNcTjqWL/yJ20aSZooUBNq/RIJ/Zfkekd0bcBY1yQI1fVdori
O6rmReoXNDZGlw3e6rw5zmsJHclk2rWADkR6J0CYI3rv5Nk7Ar5Qbk4xBZo2Z+2ifbWxFdL3Fe9e7Wi7kk6xdmzbNKcTTAhmDGJMMIdQjBHydEQZk+Knvq9yYaQ61rh76ZJbnaOPi3dHTmb4hl/KdVIWpDaFCCKGsGEwmr8AGbPwaWVMil/cp8or6uPV0ei
yeze6340/enU7k0ymUswyTUwoobZNLFgAzIBEGZPiN22qcs3c2qObwzVLht+/6+l7dbUj8+BMguiu6+i6kXUskFPGpPjDGH1VZGusafe6JTe6R68X+1+/zLiU6naBInR6hzImxV/EU6H58Za6aEOY+76bPQP9Ix3nkqeOH1DGpPiHeGp1WV3z5oZlNcPdYz
2j60OzFIp/o6pi9tb6DRtiFbMU/y1fAbpOFsTMbHFMAAAAAElFTkSuQmCC"


#*********************************************************
# Définition de l'image en tant que icone de barre
#*********************************************************
$bitmap = New-Object System.Windows.Media.Imaging.BitmapImage
$bitmap.BeginInit()
$bitmap.StreamSource = [System.IO.MemoryStream][System.Convert]::FromBase64String($Logo)
$bitmap.EndInit()
$bitmap.Freeze()

#*********************************************************
#Insertion de l'image dans la Zone Image du XAML
#*********************************************************
$image.source = $bitmap

#*********************************************************
#Les Fonctions
#*********************************************************
function GetUserWillExpired($nbDayFutur)
{
    $Base = $SearchBase.Text
    $UserList = Get-ADUser -SearchBase $Base -filter {Enabled -eq $True -and PasswordNeverExpires -eq $False} –Properties "DisplayName", "msDS-UserPasswordExpiryTimeComputed" | where { 
        $diff = New-TimeSpan ([datetime]::FromFileTime($_."msDS-UserPasswordExpiryTimeComputed")) (Get-Date)
        $diff.Days -le "0" -and $diff.Days -ge $nbDayFutur
    } | select "DisplayName", @{Name="ExpiryDate";Expression={[datetime]::FromFileTime($_."msDS-UserPasswordExpiryTimeComputed")}} | Sort-Object "DisplayName"
    Return $UserList
 }

function GetUserExpired
{
    $Base = $SearchBase.Text
    $UserListExpired = Get-ADUser -SearchBase $Base -filter {Enabled -eq $True -and PasswordNeverExpires -eq $False} –Properties "DisplayName", "msDS-UserPasswordExpiryTimeComputed" | where { 
        $diff = New-TimeSpan ([datetime]::FromFileTime($_."msDS-UserPasswordExpiryTimeComputed")) (Get-Date)
        $diff.Days -ge "0"
    } | select "DisplayName", @{Name="ExpiryDate";Expression={[datetime]::FromFileTime($_."msDS-UserPasswordExpiryTimeComputed")}} | Sort-Object "DisplayName"
    Return $UserListExpired
 }
 
#*********************************************************
#Action des boutons
#*********************************************************
 $Bt_Check.add_Click({
    $ListView.Items.Clear()
    $UserList = GetUserWillExpired(-($Tb_DayFutur.Text))
    foreach ($user in $UserList)
    {
        $ListView.items.add([pscustomobject]@{DisplayName=$user.DisplayName;ExpiryDate=$user.ExpiryDate.ToString('d MMMM yyyy')})
    }
})

$Bt_Export.add_Click({
    $dateString = (Get-Date -format "yyyy").ToString() +"_"+(Get-Date -format "MM").ToString() +"_"+(Get-Date -format "dd").ToString()
    
    $UserList = GetUserWillExpired(-($Tb_DayFutur.Text))
    if ( ($Tb_OutputFile.text).endsWith("\"))
    {
        $OutputFile = $Tb_OutputFile.Text+"AD-Pwd-WillExpired_"+$dateString+".html"
    }
    else
    {
        $OutputFile = $Tb_OutputFile.Text+"\AD-Pwd-WillExpired_"+$dateString+".html"
    }
    $UserList | ConvertTo-Html | Out-File -FilePath $OutputFile.ToString()
})

$Bt_CheckExpired.add_Click({
    $UserListExpired = GetUserExpired
    foreach ($user in $UserListExpired)
    {
        $ListViewExpired.items.add([pscustomobject]@{DisplayName=$user.DisplayName;ExpiryDate=$user.ExpiryDate.ToString('d MMMM yyyy')})
    }
})

$Bt_ExportExpired.add_Click({
    $dateString = (Get-Date -format "yyyy").ToString() +"_"+(Get-Date -format "MM").ToString() +"_"+(Get-Date -format "dd").ToString()
    
    $UserListExpired = GetUserExpired
    if ( ($Tb_OutputFile.text).endsWith("\"))
    {
        $OutputFileExpired = $Tb_OutputFileExpired.Text+"AD-Pwd-Expired_"+$dateString+".html"
    }
    else
    {
        $OutputFileExpired = $Tb_OutputFileExpired.Text+"\AD-Pwd-Expired_"+$dateString+".html"
    }
    $UserListExpired | ConvertTo-Html | Out-File -FilePath $OutputFileExpired.ToString()
})

# Display UI object
$Form.ShowDialog() | out-null